#!/bin/sh -e

PORT=8080

while getopts "p:" OPT; do
  case $OPT in
    p) PORT=$OPTARG ;;
  esac
done

if [ "$PORT" != "80" ];
then PORTSUFFIX="-on-$PORT";
else PORTSUFFIX="";
fi

PIDFILE=/usr/local/var/run/nhttpd$PORTSUFFIX.pid

[ -e $PIDFILE ] && echo pid file exists && exit 1

LOGFILE=/usr/local/var/log/nhttpd/$(date +%Y%m%d)$PORTSUFFIX

echo >>$LOGFILE $(date -u +'%F %TZ'): nhttpd starting up

nhttpd $* >>$LOGFILE 2>&1 &
PID=$!
echo $PID >$PIDFILE
sleep 1

echo node running with pid $PID on port $PORT

putbranch() {
  curl -H content-type': text/json' --data-binary '@'$1 http://localhost:${PORT}/conf/dispatch/
}

for f in $(find -L /usr/local/etc/nhttpd/branches -type f)
do
  putbranch $f
done
