// nhttpd dispatch pattern generator for 3box

// The old 3box.sh included the .3box.conf file in the request in a <script type=text/x-3box-conf>, however this version will get the conf file via XHR.  The old 3box.sh also has a complicated way of getting the number of "../" path segments to put before the required CSS and JavaScript files, but this uses absolute paths, which are given as an argument to the request handler.

// The old <title> came from the path, but the new title will be set by JavaScript and can come from the conf file (or path if none is set there).

var content='\
<!DOCTYPE html>\n\
<!--title>untitled 3box</title better not to have a useless title -->\n\
<link rel=stylesheet href=$resourcePath$3box.css>\n\
<script src=$resourcePath$timerStrategies.js></script>\n\
<script src=/3box/compat/filter.js></script>\n\
<script src=/3box/compat/forEach.js></script>\n\
<script src=/3box/compat/indexOf.js></script>\n\
<script src=/3box/compat/every.js></script>\n\
<script src=/3box/compat/map.js></script>\n\
<script src=/3box/compat/json2.js></script>\n\
<script src=$resourcePath$3box.js></script>\n\
<script src=$resourcePath$unicodeInput.js></script>\n\
<script src=$resourcePath$userPrefs.js></script>\n\
<script src=$resourcePath$feedbacks.js></script>\n\
<script src=$resourcePath$util.js></script>\n\
<script src=$resourcePath$workerUtils.js></script>\n\
<script src=$resourcePath$f_valueDictionary.js></script>\n\
<script src=$resourcePath$f_serverUpdater.js></script>\n\
<script src=$resourcePath$f_pureFeedbacks.js></script>\n\
<script src=$resourcePath$f_currentBuffer.js></script>\n\
<script src=$resourcePath$f_bufferDiff.js></script>\n\
<script src=$resourcePath$f_pureResultCache.js></script>\n\
<script src=$resourcePath$f_mainOutput.js></script>\n\
<script src=$resourcePath$f_jsEnvironment.js></script>\n\
<script src=$resourcePath$f_confParser.js></script>\n\
<script src=$resourcePath$f_fileOutput.js></script>\n\
<script src=$resourcePath$../TAL/3box_integration.js></script>\n\
<script src=$resourcePath$../TAL/parse.js></script>\n\
<script src=$resourcePath$../TAL/compile.js></script>\n\
<script src=$resourcePath$../TAL/PTNode.js></script>\n\
<script src=$resourcePath$../TAL/PTNodeTAL.js></script>\n\
<script src=$resourcePath$diff.js></script>\n\
\n\
<section id=body><select id=fname></select><output id=ruler></output><textarea id=fbody spellcheck=false></textarea></section>\n\
\n\
<section id=output><p id=status></p><p id=errors><span id=error></span><span id=timing></span></p><pre id=mainOutput></pre></section>\n\
\n\
'

var content_beta='\
<!doctype html>\n\
<title>3box v0.3pre</title>\n\
<link rel=stylesheet href=$resourcePath$3box.css>\n\
<script src=$resourcePath$../DRP/plumbing.js></script>\n\
<script src=$resourcePath$DOM_util.js></script>\n\
<script src=$resourcePath$3box_v0.3.js></script>\n\
<script src=$resourcePath$menu.js></script>\n\
<script src=$resourcePath$util.js></script>\n\
\n\
<ol id=menu></ol>\n\
\n\
<fieldset id=text_fieldset>\n\
<textarea id=text spellcheck=false></textarea>\n\
</fieldset>\n\
\n\
<div id=buttons></div>\n\
\n\
<script>$server_data$\n\
init_3box()</script>\n\
'

function htmlEntify(s){
  return s.replace(/[<&]/g,function(x){return{'<':'&lt;'
                                             ,'&':'&amp;'}[x]})}

function expand(template,values){
  return template.replace(/\$([^$]*)\$/g,function(m,cmd){
    if(cmd=='')return '$'
    return values[cmd]||''})}

exports.GET=GET
// GET :: path → Continuable Either Error Handler
function GET(resource_URI_path){return function(cont){var content_esc
  content_esc=expand(content,{resourcePath:resource_URI_path})
  cont([1,function(req,resp){var l
    l=content_esc.length
    resp.writeHead(200,{'Content-Length':l
                       ,'Content-Type':'text/html'})
    resp.write(content_esc)
    resp.end()}])}}

exports.GET_beta=GET_beta
function GET_beta(resource_URI_path)
{return function(cont)
 {var content_esc,l
  content_esc=expand(content_beta,{resourcePath:resource_URI_path,server_data:'server_data={base_uri:"'+resource_URI_path+'"};'})
  l=content_esc.length
  cont
  ([1,function(req,resp)
    {resp.writeHead(200,{'Content-Length':l,'Content-Type':'text/html'})
     resp.write(content_esc)
     resp.end()}])}}
