// Nhttpd dispatch for ed (the generic fallback text editor)
//
// ed is just a textarea with some code that automatically PUTs updated  
// file contents to the server after some seconds of inactivity.

var HANDLER=0
  , METHOD=1
  , PATHHEAD=2

exports.edGenerator=edGenerator
// edGenerator :: (String, String) → String → Continuable Maybe Pattern
function edGenerator(path,staticURI){var contents
 if(path.slice(-1)!=='/')throw new Error('edGenerator: path must include trailing slash') // TODO: resolve relative paths
 return function _edGenerator(pathHead){return function(cont){var isDir
   isDir=pathHead.slice(-1)==='/'
   if(isDir)cont({test:pathHead
                 ,then:[PATHHEAD,[{generator:edGenerator(path+pathHead,staticURI)}]]})
   else cont({test:pathHead
             ,then:edHandler(path+pathHead.slice(0,-3),staticURI)})}}}

function edHandler(path,uri){
  return [METHOD,[{test:'GET'
                  ,then:[HANDLER,edHandlerGET(path,uri)]}]]}

function htmlEntify(s){
  return s.replace(/[<&]/g,function(x){return{'<':'&lt;'
                                             ,'&':'&amp;'}[x]})}

function expand(template,values){
  return template.replace(/\$([^$]*)\$/g,function(m,cmd){
    if(cmd=='')return '$'
    return values[cmd]||''})}

var _precontent='\
<!doctype html>\n\
<title>$filename$ ed</title>\n\
<link rel=stylesheet href=$staticURI$ed.css>\n\
<script src=$staticURI$js/unicodeInput.js></script>\n\
<script src=$staticURI$js/userPrefs.js></script>\n\
<script src=$staticURI$js/ed.js></script>\n\
<fieldset>\n\
<label><a href="$filename$">$filename$</a>\n\
<textarea name=content id=content spellcheck=false>\n\
'
var _postcontent='\
</textarea>\n\
\n\
</label>\n\
</fieldset>\n\
<p id=status></p>\n\
<ol id=buttons>\n\
<li><input type=button id=tag value=tag>\n\
</ol>\n\
<p id=output></p>\n\
'

// the ed GET handler.
function edHandlerGET(path,uri){return function _edHandlerGET(req,resp){var dict
  dict={'filename':path.slice(path.lastIndexOf('/')+1)
       ,'staticURI':uri} // URI prefix where the js and css can be found
  precontent=expand(_precontent,dict)
  postcontent=expand(_postcontent,dict)
  length=precontent.length+postcontent.length
  resp.writeHead(200,{'Content-Type':'text/html'
                     ,'Content-Length':length})
  resp.write(precontent+postcontent)
  resp.end()}}
