// Configuration is a template file name.
// The handler expects a POST request with a JSON object in the body.
// It expands the template using the JSON data, and then runs the result through pdflatex and serves the PDF as the response.

var fs=require('fs')
  , child_process=require('child_process')
  , sys=require('sys')
  , staticFile=require('./staticFile')
  , handlers=require('./handlers')
  , url=require('url')

// POST :: Path → Continuable Either Error Handler
exports.POST=POST
function POST(template_path){return function(cont){
  fs.readFile(template_path,'utf8',function(err,template){
   if(err)return cont([0,err])
   cont([1,_GET(template)])})}} // XXX GET != POST

// _POST :: String → Handler

function _POST(template){return function __POST(req,resp){var body
  req.setEncoding('utf8')
  body=""
  req.on('data',function(chunk){body+=chunk})
  req.on('end',function(){var template_data,expanded,tmpfile
    try{template_data=JSON.parse(body)}
    catch(e){handlers.error(400,'Bad Request','Could not parse request body as JSON: '+e)(req,resp);return}
    expanded=expand_template(template,template_data)
    tmpfile='/tmp/pdf_templ-'+Date.now()
    fs.writeFile(tmpfile,expanded,function(err){
      if(err){handlers.error(500,'Server Error','Could not write temporary file '+tmpfile+': '+err)(req,resp);return}
      child_process.exec('pdflatex -output-directory /tmp '+tmpfile,undefined,function(err,stdout,stderr){
        sys.print(stdout)
        sys.print(stderr)
        staticFile._staticFileGET(tmpfile+'.pdf')(req,resp)})})})}}

// unfortunately the querystring parser provided with node is unusable.
function parse_querystring(s){var xs,ret={}
 xs=s.split('&')
 xs.forEach(function(x){var pair
   pair=x.split('=')
   ret[decode(pair[0])]=decode(pair[1])})
 return ret
 function decode(s){return decodeURIComponent(s).replace(/\+/g,' ')}}

function _GET(template){return function __POST(req,resp){var body,template_data
  template_data=parse_querystring(url.parse(req.url).query)
  expanded=expand_template(template,template_data)
  dbg2(template_data)
  tmpfile='/tmp/pdf_templ-'+Date.now()
  fs.writeFile(tmpfile,expanded,function(err){
    if(err){handlers.error(500,'Server Error','Could not write temporary file '+tmpfile+': '+err)(req,resp);return}
    child_process.exec('pdflatex -output-directory /tmp '+tmpfile,undefined,function(err,stdout,stderr){
      sys.print(stdout)
      sys.print(stderr)
      staticFile._staticFileGET(tmpfile+'.pdf')(req,resp)})})}}

// XXX put this in a module somewhere

function expand_template(template,dict){
 return template.replace(/\$([^$]*)\$/g,function(m,m1){
  if(hasprop(dict,m1))return dict[m1]
  return ''})}

function hasprop(o,p){return Object.prototype.hasOwnProperty.call(o,p)}
