var sys=require('sys')
  , file=require('./deps/fs-continuable')
  , E=require('./deps/either')
  , serverID='nhttpd v0.0.7pre'
// Handlers module, includes a variety of request handler types and 
// useful related functions.

// When a request handler type has not been implemented yet, it can 
// be defined as an alias of this:
exports.unimplemented=unimplemented=error(500,"Server Error","Request handler not yet implemented.")

exports.handle401=error(401,"Authorization Required","Authentication is required to access this resource.")
exports.handle403=error(403,"Forbidden","You do not have permission to access this resource.")
exports.handle404=error(404,"Not Found","There is nothing here.")
exports.handle405=error(405,"Method not Allowed","This resource does not support this method.")

exports.hello_world=status_type_body(200,"text/html","<!doctype html><title>Hello, world!</title><h1>Hello, World!</h1><p>It worked!</p>")

function dump(x){sys.puts(x===undefined?'undefined':JSON.stringify(x,null,1))}

// used for error pages
function expandTemplateFile(name,dict,f,g){var s
  if(Object.prototype.hasOwnProperty.call(expandTemplateFile.cache,name)){
    f(expandTemplateFile.cache[name].replace(/\$([^$]*)\$/g,function(m,n){
      if(n=='')return '$'
      return dict[n]}))}
  else{
    file.readFile('../templates/'+name)(E.either(g,function(s){
      expandTemplateFile.cache[name]=s
      expandTemplateFile(name,dict,f)}))}}

expandTemplateFile.cache={}

exports.error=error
function error(code,summary,message){
  return function(req,resp){
    if(!resp) throw new Error('xxx - debug')
    expandTemplateFile('HTTP_error_page',{status:code
                                         ,summary:summary
                                         ,message:message
                                         ,serverID:serverID}
    ,function(body){
      resp.writeHead(code,{'Content-Type':'text/html'
                          ,'Content-Length':body.length})
      // sending ASCII here, since if we sent UTF-8 the Content-Length 
      // would be wrong.
      // better would be to convert to UTF-8 first, then take length, 
      // then send as 'binary'.
      resp.write(body)
      resp.end()}
    ,function(){
      dump('Fatal: unable to read error template file (pwd: '+process.cwd()+')')
      resp.writeHead(500,{'Content-Type':'text/html'})
      resp.write('<h1>500 Server Error</h1><p>The server encountered an internal error while processing an error handler.')
      resp.end()})}}

exports.status_type_body=status_type_body
function status_type_body(status,type,body){
  return function(req,resp){
    resp.writeHead(status,{'Content-Type':type
                          ,'Content-Length':body.length})
    resp.write(body)
    resp.end()}}