// Serving static files.

var fs=require('./deps/fs-continuable')
  , E=require('./deps/either')
  , either=E.either,Left=E.left,Right=E.Right,replaceRight=E.replaceRight,replaceLeft=E.replaceLeft
  , handlers=require('./handlers')
    // mapping for file extensions to MIME types
  , contentTypes={"js"     :"text/javascript"
                 ,"html"   :"text/html"
                 ,"xhtml"  :"application/xhtml+xml"
                 ,"css"    :"text/css"
                 ,"jpg"    :"image/jpeg"
                 ,"jpeg"   :"image/jpeg"
                 ,"png"    :"image/png"
                 ,"svg"    :"image/svg+xml"
                 ,"atom"   :"application/atom+xml"
                 ,"pdf"    :"application/pdf"
                 }
  , charset="UTF-8"

exports.staticFileDispatch=staticFileDispatch
// staticFileDispatch :: Path → String → Continuable Maybe Pattern
function staticFileDispatch(path){var contents
  if(path[0]!=='/'||path.slice(-1)!=='/')throw new Error('staticFileDispatch path must be absolute and include trailing slash')
  return function _staticFileDispatch(pathHead){return function(cont){
    if(!contents||(new Date)-contents.ts>2000){// directory contents not already cached or more than 2s old
      fs.readdir(path)(replaceRight(cont)(function(paths){var x
        contents={paths:paths,ts:+new Date}
        withContents()}))}
    else withContents()
    function withContents(){var i,l,isDir,noSlash
      isDir=pathHead.slice(-1)==='/'
      if(isDir)noSlash=pathHead.slice(0,-1)
      for(i=0,l=contents.paths.length;i<l;i++){
        if(isDir&&contents.paths[i]===noSlash){
          cont({test:pathHead
               ,then:[PATHHEAD,[{generator:staticFileDispatch(path+pathHead)
                                ,uri:'/lib/generators/staticFileDispatch' // XXX
                                ,args:[path+pathHead]}]]})
          return}
        if(!isDir&&contents.paths[i]===pathHead){
          cont({test:pathHead // XXX this shouldn't really be necessary, this should be done outside
               ,then:staticFileHandler(path+pathHead)})
          return}}
      cont()}}}}

function staticFileHandler(path){
  return [METHOD,[{test:'GET'
                  ,then:[HANDLER,_staticFileGET(path)]}]]}

exports.staticFileGET=staticFileGET
// staticFileGET :: Path → Continuable Either Error Handler
function staticFileGET(path){return function(cont){
  cont(Right(_staticFileGET(path)))}}

exports._staticFileGET=_staticFileGET
// _staticFileGet :: Path → Handler
function _staticFileGET(path,opts){return function(req,resp){
  opts=opts||{}
  fs.stat(path)
  (either(send403,function(stats){var length,ext,mime,lastdot,hdrs
    length=stats.size
    lastdot=path.lastIndexOf('.')
    ext=opts.ext || (lastdot>-1 ? path.slice(lastdot+1) : '')
    mime=opts.mime || contentTypes[ext] || opts.mime_default
    hdrs={"Content-Length":length}
    if(mime){hdrs["Content-Type"]=mime+'; charset='+charset}
    resp.writeHead(200,hdrs)
    sendStream(fs.streamFile(path,'binary'),req,resp)}))
  function send403(){handlers.handle403(req,resp)}}}

exports.sendStream=sendStream
function sendStream(s,req,resp){var we_are_committed=false
  s(function(m,x){switch(m){
    case 'chunk': we_are_committed=true;resp.write(x,'binary');s('next');break
    case 'eof': resp.end();break
    case 'error': if(we_are_committed){resp.end();req.connection.close()}
                  else handlers.error(500,'Internal Server Error','could not read from file: '+path)(req,resp)
                  break}})}